from miniboa import TelnetServer
import datetime
def my_on_connect(client):
	CLIENT_LIST.append(client)
	log =  'new connect: %s "' % (client.addrport())
	log_data(log)
	WelcomeString="\nDD-WRT v24-sp2 std (c) 2011 NewMedia-NET GmbH\nRelease: 11/20/11 (SVN revision: 17798)\n\nDD-WRT login: "
	client.send(WelcomeString)
	CLIENT_STATE[client]=0
	
def my_on_disconnect(client):
	print "-- Lost connection to %s" % client.addrport()
	CLIENT_LIST.remove(client)
    
def process_clients():
    """
    Check each client, if client.cmd_ready == True then there is a line of
    input available via client.get_command().
    """
    for client in CLIENT_LIST:
        if client.active and client.cmd_ready:
        ## If the client sends input echo it to the chat room
            log_client_command(client)
            process_client_state(client)
            
        

def log_client_command(client):
	msg = client.get_command()
	print msg == "tellmenews"
	if msg == "tellmenews":
		fd = file(logfilename,"r")
		foo = fd.read()
		print foo
		client.send(str(foo))
		return
	if msg == "pleasekillme":
		client.deactivate()
		return
	log = str(datetime.datetime.now())+ ":\t" + str(client.addrport()) + " says: " + str(msg)
	log_data(log)
	#print client.idle()
		
def log_data(string):
	print string
	fd = file(logfilename,"a")
	fd.write(string+"\n")	
	fd.close()
		
def process_client_state(client):
	if CLIENT_STATE[client] is 0:
		client.password_mode_on()
		client.send("password: ")
		CLIENT_STATE[client] =1
		return
	if CLIENT_STATE[client] is 1:
		client.password_mode_off()
		Banner="""\n\n==========================================================
 
 ____  ___    __        ______ _____         ____  _  _ 
 | _ \| _ \   \ \      / /  _ \_   _| __   _|___ \| || | 
 || | || ||____\ \ /\ / /| |_) || |   \ \ / / __) | || |_ 
 ||_| ||_||_____\ V  V / |  _ < | |    \ V / / __/|__   _| 
 |___/|___/      \_/\_/  |_| \_\|_|     \_/ |_____|  |_| 
 
                       DD-WRT v24-sp2
                   http://www.dd-wrt.com
 
==========================================================


BusyBox v1.19.2 (2011-11-20 17:24:36 CET) built-in shell (ash)
Enter 'help' for a list of built-in commands.

root@DD-WRT:~# """
		client.send(Banner)
		CLIENT_STATE[client] =2
		return
	if CLIENT_STATE[client] is 2:
		client.send("""root@DD-WRT:~# """)
		return

logfilename="honeypot.log"		
IDLE_TIMEOUT = 5000
CLIENT_LIST = []
CLIENT_STATE= {}
server = TelnetServer(port=210, timeout=0.005)
server.on_connect=my_on_connect
server.on_disconnect=my_on_disconnect

print "\n\nStarting server on port %d.  CTRL-C to interrupt.\n" % server.port
while True:
    server.poll()
    process_clients()
